.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateControls  PROTO   :DWORD
EnumResTypesProc        PROTO   :DWORD,:DWORD,:DWORD
EnumNamesProc           PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ConvertToASCII  PROTO   :DWORD,:DWORD
EnumNamesProc2  PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\comctl32.inc
include c:\masm32\include\gdi32.inc

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\comctl32.lib
includelib c:\masm32\lib\gdi32.lib

.const

MainWindowWidth         equ             600
MainWindowHeight        equ             400

.data

hInstance               HINSTANCE              ?
CommandLine            LPSTR                  ?

; ++++ Main Window related ++++

hMainWindow             dd                      ?
MainWindowClass         db              'MainWindowClass',0
MainWindowName          db              'MainWindowName',0

; ++++ TreeView related +++++

hTreeView               dd                      ?
TreeViewClass           db              'SysTreeView32',0
tvis                    TV_INSERTSTRUCT         <>
tvi                     TV_ITEM                         <>

; ++++ ListView related ++++

hListView               dd                      ?
ListViewClass           db                'SysListView32',0
lvi                   LV_ITEM                           <>

; ++++ Static   related ++++

hStatic                 dd                      ?
StaticClass             db              'STATIC',0

; ++++ Others ++++

rect            RECT            <>
szExplorer      db              'c:\windows\system32\shell32.dll',0
hExplorer       dd                              ?
ResTypesBuffer          dd      256 dup(0)
lpResTypes             dd      OFFSET ResTypesBuffer
NumBuffer       db      8 dup('0'),'H',0
xlat_table      db      '0123456789ABCDEF',0

SystemDefinedResourceTypes   LABEL   DWORD
                                  dd     RT_ACCELERATOR
szAccel                         db      'RT_ACCELERATOR',0	;ccelerator table
                                    dd       RT_ANICURSOR
szAniCursor                   db       'RT_ANICURSOR',0     	;nimated cursor
                                   dd        RT_ANIICON
szAniIcon                       db      'ANIICON',0                          ;Animated icon
                                    dd     RT_BITMAP
szBitmap                        db      'RT_BITMAP',0           	;Bitmap resource
                                    dd       RT_CURSOR
szCursor                        db      'RT_CURSOR',0           	;Hardware-dependent cursor resource
                                    dd       RT_DIALOG
szDialog                         db      'RT_DIALOG',0           	;Dialog box
                                     dd      RT_FONT
szFont                            db      'RT_FONT',0             	;Font resource
                                     dd      RT_FONTDIR
szFontDir                        db      'RT_FONTDIR',0          	;Font directory resource
                                     dd      RT_GROUP_CURSOR
szGroupCursor                db      'RT_GROUP_CURSOR',0	;Hardware-independent cursor resource
                                     dd       RT_GROUP_ICON
szGroupIcon                    db      'RT_GROUP_ICON',0       	;Hardware-independent icon resource
                                     dd       RT_ICON
szIcon                            db      'RT_ICON',0                     	;Hardware-dependent icon resource
                                     dd      RT_MENU
szMenu                          db      'RT_MENU',0             	;Menu resource
 ;                                      dd      RT_MESSAGETABLE
 ; szMsgTable                    db      'RT_MESSAGETABLE',0          ;Message-table entry
                                     dd      RT_RCDATA
szRCData                        db      'RT_RCDATA',0           	;Application-defined resource (raw data)
                                     dd       RT_STRING
szString                          db      'RT_STRING',0           	;String-table entry
                                      dd      RT_VERSION
szVersion                        db      'RT_VERSION',0
SystemDefinedResourceTypesEnd   LABEL   DWORD
sdrt_count              dd              0
szBmp   db      'c:\masm32\asm\res2\ico.ico',0
RnStart         db      'ResNamesStart',0
ResNamesBuffer  dd     1024     Dup(0)
lpResNamesBuffer      dd      offset ResNamesBuffer
RnEnd   db              'ResNamesEnd',0

.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  WinMain,hInstance,NULL,addr CommandLine,SW_SHOWNORMAL
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

                local   msg:MSG
                local   wc:WNDCLASSEX

                mov     wc.cbSize,sizeof wc
                mov     wc.style,CS_HREDRAW+CS_VREDRAW
                mov     wc.lpfnWndProc,offset WndProc
                mov     wc.cbClsExtra,NULL
                mov     wc.cbWndExtra,NULL
                mov     wc.lpszMenuName,NULL
                mov     wc.lpszClassName,offset MainWindowClass
                mov     wc.hbrBackground,COLOR_WINDOW
                push    hInst
                pop     wc.hInstance
                invoke  LoadIcon,NULL,IDI_APPLICATION
                mov     wc.hIcon,eax
                mov     wc.hIconSm,eax
                invoke  LoadCursor,NULL,IDC_ARROW
                mov     wc.hCursor,eax
                invoke  RegisterClassEx,addr wc

                invoke  GetSystemMetrics,SM_CYSCREEN
                shr     eax,1
                sub     eax,MainWindowHeight/2
                push    eax
                invoke  GetSystemMetrics,SM_CXSCREEN
                shr     eax,1
                sub     eax,MainWindowWidth/2
                pop     ebx


                invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW,\
                                        eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
                mov     hMainWindow,eax
                invoke  ShowWindow,eax,SW_SHOW
                invoke  UpdateWindow,hMainWindow

msg_loop:
                invoke  GetMessage,addr msg,NULL,0,0
                cmp     eax,NULL
                je        end_msg_loop
                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg
                jmp     msg_loop
end_msg_loop:
                mov     eax,msg.wParam
                ret
                
WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

                local   hResource:DWORD
                local   hList:DWORD
                local   hList2:DWORD
                local   hIndex:DWORD
                local   hResFind:DWORD
                local   hResLock:DWORD
                local   hMemDC:DWORD
                local   hBmp:DWORD
                
             .if     uMsg==WM_DESTROY
                     invoke  PostQuitMessage,NULL
             .elseif    uMsg==WM_CREATE
                        invoke  InitCommonControls
                        invoke  CreateControls,hWnd
                        call    InitRes
              .elseif    uMsg==WM_NOTIFY
                    

                        mov     eax,lParam
                        .if     [eax.NM_TREEVIEW].hdr.code==TVN_SELCHANGED
                                invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,[eax.NM_TREEVIEW].itemNew.hItem
                                .if     eax==NULL
                                        
                                .endif
                        .endif                                                                                                        
                     .else
                             invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                             ret
                     .endif
                             xor     eax,eax
                             ret
                     
WndProc endp
        
InitRes         PROC
        
                invoke  LoadLibrary,addr szExplorer
                mov     hExplorer,eax
                invoke  EnumResourceTypes,hExplorer,addr EnumResTypesProc,NULL
                mov     tvis.hInsertAfter,TVI_LAST
                mov     tvis.item.imask,TVIF_TEXT
                lea       esi,ResTypesBuffer
                cld
@@1:
                mov     tvis.hParent,NULL
                lea     edi,SystemDefinedResourceTypes
                lodsd
                cmp     eax,NULL
                je      no_resource
                ror     eax,16
                cmp     ax,0
                jne     type_is_string
                rol     eax,16
comp:                
                cmp     eax,dword ptr [edi]
                je      resource_found
                cmp     edi,offset SystemDefinedResourceTypesEnd
                jb       realign_pointer
                invoke  ConvertToASCII,eax,addr NumBuffer
                mov     tvis.item.pszText,offset NumBuffer
                jmp     sdrt_exceeded

realign_pointer:
                add     edi,3
realign_loop:              
                inc     edi  
                cmp     byte ptr [edi],0
                jne     realign_loop
                inc     edi
                jmp     comp
resource_found:
                add     edi,4
                mov     tvis.item.pszText,edi

sdrt_exceeded:
                mov     tvis.item.imask,TVIF_PARAM+TVIF_TEXT
                mov     tvis.item.lParam,eax      
                push    eax
                invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
                mov     tvis.hParent,eax
                pop     eax
                invoke  EnumResourceNames,hExplorer,eax,addr EnumNamesProc,NULL
                jmp     @@1
type_is_string:
                sub     esi,4
                lodsb
                cmp     al,'#'
                je     tis_skip
                dec     esi
tis_skip:                
                mov     tvis.item.imask,TVIF_TEXT
                mov     tvis.item.pszText,esi
                invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
                mov     tvis.hParent,eax
                invoke  EnumResourceNames,hExplorer,tvis.item.pszText,addr EnumNamesProc,NULL
realign_pointer2:
                inc     esi
                cmp     byte ptr [esi],0
                jne     realign_pointer2
                inc     esi
                jmp     @@1
 
no_resource:
                ret
                                                                
InitRes         endp

EnumNamesProc    PROC    hModule:DWORD,lpszType:DWORD,lpszName:DWORD,lParam:DWORD

                pushad
                pushfd
                mov     eax,lpszName
                cmp     eax,0
                je      ret_false
                cmp     ah,'#'
                jne     skip_1
                xor     ah,ah
                movzx   eax,al
                jmp     skip_2
skip_1:                               
                ror     eax,16
                cmp     ax,0
                jne     name_is_string
                rol     eax,16
skip_2:                
                invoke  ConvertToASCII,eax,addr NumBuffer
                mov     tvis.item.imask,TVIF_PARAM+TVIF_TEXT
                mov     tvis.item.pszText,offset NumBuffer
                mov     tvis.item.lParam,eax
                invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
                jmp     ret_true
name_is_string:
                mov     esi,lpszName
                cld
                lodsb
                cmp     al,'#'
                je      nis_skip
                dec     esi
nis_skip:
                mov     tvis.item.imask,TVIF_TEXT
                push    esi
                pop     tvis.item.pszText
                invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
ret_true:
                popfd
                popad
                mov     eax,TRUE
                ret
ret_false:
                mov     eax,FALSE
                popfd
                popad                
                ret

EnumNamesProc    endp                                                
               
EnumResTypesProc        PROC    hModule:DWORD,lpszType:DWORD,lParam:DWORD

                pushad
                pushfd
                mov     edi,lpResTypes
                cld
                mov     eax,lpszType
                cmp     eax,0
                je        ret_false
                ror     eax,16
                cmp     ax,0  
                jne      type_is_string
                rol     eax,16
                stosd
                jmp     ret_true
type_is_string:
                mov     esi,lpszType
nis_loop:                
                lodsb
                cmp     al,0
                je      end_nis
                stosb
                jmp     nis_loop
end_nis:
                stosb
ret_true:
                mov     lpResTypes,edi
                popfd
                popad
                mov     eax,TRUE
                ret

ret_false:
                xor     eax,eax
                stosd
                popfd
                popad
                mov     eax,FALSE
                ret

EnumResTypesProc    endp

ConvertToASCII  PROC    val:DWORD,lpBuffer:DWORD

               push    eax
               push    ebx
               push    edx
               push    ecx                        
               pushfd                                      
               mov     edi,lpBuffer
               push    edi
               mov     ecx,8
               mov     al,'0'
               cld
looper1:                
               stosb     
               loopnz  looper1
               pop     edi                                           
               mov     eax,val
               mov     ebx,010h                        
               add     edi,7
               std
looper:
               xor     edx,edx
               div     ebx
               cmp      eax,0
               je      end_looper
               push    eax
               push    ebx
               mov     al,dl
               lea     ebx,xlat_table
               xlat    
               stosb
               pop     ebx
               pop     eax
               jmp     looper
end_looper:
               mov     al,dl
               lea     ebx,xlat_table
               xlat
               stosb
               popfd
               pop     ecx
               pop     edx
               pop     ebx
               pop     eax                                                                                                
               ret

ConvertToASCII  endp

CreateControls  PROC    hWnd:DWORD

                        local   lvc:LV_COLUMN
                        
                        invoke  GetClientRect,hWnd,addr rect
                        push    rect.right
                        shr     rect.right,2
                        invoke  CreateWindowEx,NULL,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+TVS_HASLINES+TVS_LINESATROOT+TVS_HASBUTTONS,\
                                        0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                        mov     hTreeView,eax
                        pop     rect.right
                        mov     eax,rect.right
                        shr     eax,2
                        add     eax,2
                        sub     rect.right,eax
                        sub     rect.bottom,34
                        invoke  CreateWindowEx,NULL,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD+LVS_ICON,\
                                        eax,NULL,rect.right,rect.bottom,hWnd,0100h,hInstance,NULL
                        mov     hListView,eax
                        ret
                        
CreateControls  endp  
                
end     start                